Index: /main/trunk/greenstone3/.classpath
===================================================================
--- /main/trunk/greenstone3/.classpath	(revision 26468)
+++ /main/trunk/greenstone3/.classpath	(revision 26468)
@@ -0,0 +1,96 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<classpath>
+	<classpathentry kind="src" path="gli/src"/>
+	<classpathentry kind="src" path="src/java"/>
+	<classpathentry kind="lib" path="admin/cp.jar"/>
+	<classpathentry kind="lib" path="admin/GAI.jar"/>
+	<classpathentry kind="lib" path="build/GAI.jar"/>
+	<classpathentry kind="lib" path="build/gsdl3.jar"/>
+	<classpathentry kind="lib" path="build/gsdl3test.jar"/>
+	<classpathentry kind="lib" path="build/gutil.jar"/>
+	<classpathentry kind="lib" path="build/phind.jar"/>
+	<classpathentry kind="lib" path="build/server.jar"/>
+	<classpathentry kind="lib" path="cp.jar"/>
+	<classpathentry kind="lib" path="gs2build/bin/java/ApplyXSLT.jar"/>
+	<classpathentry kind="lib" path="gs2build/bin/java/GLIServer.jar"/>
+	<classpathentry kind="lib" path="gs2build/bin/java/JDBMWrapper.jar"/>
+	<classpathentry kind="lib" path="gs2build/bin/java/LuceneWrapper3.jar"/>
+	<classpathentry kind="lib" path="gs2build/bin/java/xalan.jar"/>
+	<classpathentry kind="lib" path="gs2build/common-src/indexers/lucene-gs/lib/lucene-core-2.3.2.jar"/>
+	<classpathentry kind="lib" path="gs2build/common-src/indexers/lucene-gs/lib/lucene-core-3.3.0.jar"/>
+	<classpathentry kind="lib" path="gs2build/common-src/indexers/lucene-gs/LuceneWrapper3.jar"/>
+	<classpathentry kind="lib" path="gs2build/common-src/indexers/mg/mg.jar"/>
+	<classpathentry kind="lib" path="gs2build/common-src/indexers/mgpp/mgpp.jar"/>
+	<classpathentry kind="lib" path="gs2build/common-src/packages/jdbm/jdbm-1.0/dist/jdbm-1.0.jar"/>
+	<classpathentry kind="lib" path="gs2build/lib/java/jdbm.jar"/>
+	<classpathentry kind="lib" path="lib/java/ant-contrib-1.0b3.jar"/>
+	<classpathentry kind="lib" path="lib/java/AntelopeTasks_3.4.2.jar"/>
+	<classpathentry kind="lib" path="lib/java/anttasks.jar"/>
+	<classpathentry kind="lib" path="lib/java/cp.jar"/>
+	<classpathentry kind="lib" path="lib/java/ganymed.jar"/>
+	<classpathentry kind="lib" path="lib/java/Java_svn.jar"/>
+	<classpathentry kind="lib" path="lib/java/svnant.jar"/>
+	<classpathentry kind="lib" path="lib/java/svnClientAdapter.jar"/>
+	<classpathentry kind="lib" path="lib/java/svnjavahl.jar"/>
+	<classpathentry kind="lib" path="lib/java/svnkit.jar"/>
+	<classpathentry kind="lib" path="lib/java/xmltask.jar"/>
+	<classpathentry kind="lib" path="lib/jni/cp.jar"/>
+	<classpathentry kind="lib" path="lib/jni/javagdbm.jar"/>
+	<classpathentry kind="lib" path="lib/jni/mg.jar"/>
+	<classpathentry kind="lib" path="lib/jni/mgpp.jar"/>
+	<classpathentry kind="lib" path="packages/tomcat/lib/servlet-api.jar"/>
+	<classpathentry kind="lib" path="server.jar"/>
+	<classpathentry kind="lib" path="src/packages/javagdbm/javagdbm.jar"/>
+	<classpathentry kind="lib" path="web/applet/phind.jar"/>
+	<classpathentry kind="lib" path="web/applet/xercesImpl.jar"/>
+	<classpathentry kind="lib" path="web/applet/xml-apis.jar"/>
+	<classpathentry kind="lib" path="web/sites/localsite/collect/lucene-jdbm-demo/tests/tests.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/activation.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/ant.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/axis-ant.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/axis.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/bsf.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/commons-codec-1.7.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/commons-discovery-0.2.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/commons-fileupload-1.2.2.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/commons-io-2.1.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/commons-lang3-3.0-beta.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/commons-logging-1.0.4.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/cp.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/derby.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/DLservices.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/fedora.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/fedoraGS3.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/GAI.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/gsdl3.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/gson-1.7.1.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/gutil.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/jaxp.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/jaxrpc.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/jdbm.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/je-4.1.10.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/js.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/junit.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/log4j-1.2.8.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/lucene-1.4.1.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/LuceneWrapper3.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/mail.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/maxent-2.4.0.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/recaptcha4j-0.0.7.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/saaj.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/serializer.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/stanford-parser-2010-11-30.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/trove.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/urlrewrite-2.6.0.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/wsdl4j-1.5.1.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/xalan.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/xercesImpl.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/xml-apis.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/xmlsec-1.2.1.jar"/>
+	<classpathentry kind="lib" path="web/WEB-INF/lib/xsltc.jar"/>
+	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
+	<classpathentry kind="lib" path="gli/lib/apache.jar"/>
+	<classpathentry kind="lib" path="gli/lib/qfslib.jar"/>
+	<classpathentry kind="lib" path="gli/lib/rsyntaxtextarea.jar"/>
+	<classpathentry kind="output" path="web/WEB-INF/classes"/>
+</classpath>
Index: /main/trunk/greenstone3/.project
===================================================================
--- /main/trunk/greenstone3/.project	(revision 26468)
+++ /main/trunk/greenstone3/.project	(revision 26468)
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>greenstone3</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>org.eclipse.jdt.core.javabuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>org.eclipse.jdt.core.javanature</nature>
+	</natures>
+</projectDescription>