Index: /main/trunk/model-cols/niupepa/resources/niupepa.properties
===================================================================
--- /main/trunk/model-cols/niupepa/resources/niupepa.properties	(revision 26480)
+++ /main/trunk/model-cols/niupepa/resources/niupepa.properties	(revision 26481)
@@ -18,15 +18,14 @@
 simple.query=Search {0-subcolllist} for {1-some/all} of the words {2-query box}
 about.changelangtofrommaori=View the collection in Māori
-about.textxwelcome=<h2>Welcome to the Māori Niupepa Collection</h2>
-about.textxwelcome2=<p>Here we have a collection of historic newspapers published primarily for a Māori audience between 1842 and 1932. The newspapers can be <gsf:link type="query"><b>searched</b></gsf:link> (full text), <gsf:link type="classifier" nodeID="CL1"><b>browsed</b></gsf:link> (by series) or accessed by <gsf:link type="classifier" nodeID="CL2"><b>date</b></gsf:link>. This collection has been made available by the <a href="http://www.nzdl.org">New Zealand Digital Library Project</a>, at the <a href="http://www.cs.waikato.ac.nz/cs/">Department of Computer Science</a>, <a href="http://www.waikato.ac.nz">University of Waikato</a>.</p>
-about.textxbackground=<p>Background information about the collection can be accessed below.</p>
-about.textxgrateful=<p>We are grateful for the support of many organisations that have assisted in making this collection freely available, in particular the <a href="http://www.minedu.govt.nz">Ministry of Education</a> and university libraries throughout New Zealand. Please see our supporting organisations section below.</p>
+about.textxwelcome=Welcome to the Māori Niupepa Collection
+about.textxwelcome2=Here we have a collection of historic newspapers published primarily for a Māori audience between 1842 and 1932. The newspapers can be <gsf:link type="query"><b>searched</b></gsf:link> (full text), <gsf:link type="classifier" nodeID="CL1"><b>browsed</b></gsf:link> (by series) or accessed by <gsf:link type="classifier" nodeID="CL2"><b>date</b></gsf:link>. This collection has been made available by the <a href="http://www.nzdl.org">New Zealand Digital Library Project</a>, at the <a href="http://www.cs.waikato.ac.nz/cs/">Department of Computer Science</a>, <a href="http://www.waikato.ac.nz">University of Waikato</a>.
+about.textxbackground=<a href="#background">Background information</a> about the collection can be accessed below.
+about.textxgrateful=We are grateful for the support of many organisations that have assisted in making this collection freely available, in particular the <a href="http://www.minedu.govt.nz">Ministry of Education</a> and university libraries throughout New Zealand. Please see our <a href="#support">supporting organisations</a> section below.
 
-about.textxbackground2=<h2>Background Information</h2>
+about.textxbackground2=Background Information
 about.textxbackground3=<p>The niupepa collection consists of over 17,000 pages taken from 34 separate periodicals. It is based on &quot;Niupepa 1842-1933&quot;, a microfiche collection produced by the <a href="http://www.natlib.govt.nz/en/using/8atl.html">Alexander Turnbull Library</a>. 70% of the collection is written solely in Māori, 27% is bilingual and about 3% is written in English. There were three main types of niupepa published; government sponsored, Māori initiated, and religious.</p><p>There are four main parts to the Māori niupepa collection:</p><ul><li>facsimile images of the original pages</li><li>text extracted from the newspapers (for searching)</li><li>bibliographic commentaries for each newspaper title</li><li><gsf:link type="page" page="abexpl">English abstracts</gsf:link> for each issue</li></ul><p>Further information about the Niupepa Collection can be found in <i>Rere Atu Taku Manu! Discovering History, Language &amp; Politics in the Māori Language Newspapers</i>. Edited by Jennifer Curnow, Ngapare Hopa, and Jane McRae. Auckland University Press (2002). </p>
 
 about.textxsupporgs=<h2>Supporting Organisations</h2>
-about.textximage=<a href="http://www.minedu.govt.nz/"><img src="http://www.minedu.govt.nz/minedu/images/ui/header/moe-logo.gif" style="border:0px;"/></a>
-about.textyaymined=<p>The <a href="http://www.minedu.govt.nz">Ministry of Education</a> are the principal sponsors of this project.</p>
+about.textyaymined=The <a href="http://www.minedu.govt.nz">Ministry of Education</a> are the principal sponsors of this project.
 about.textxsupporgs2=<p>Financial support was also generously given by the following university libraries:</p><ul><li><a href="http://www.waikato.ac.nz/library/">Waikato University Library</a></li><li><a href="http://www.library.otago.ac.nz">Otago University Library</a></li><li><a href="http://www.massey.ac.nz/~wwwlib/">Massey University Library</a></li><li><a href="http://www.victoria.ac.nz/library/">Victoria University Library</a></li><li><a href="http://www2.auckland.ac.nz/lbr/">Auckland University Library</a></li><li><a href="http://library.canterbury.ac.nz">Canterbury University Library</a></li><li><a href="http://prod.lincoln.ac.nz/libr/default.htm">Lincoln University Library</a></li></ul><p>The newspapers are also available on 35mm microfilm and microfiche. They can be borrowed on interloan through your local library or purchased from the <a href="http://www.natlib.govt.nz/en/using/8atl.html">Alexander Turnbull Library</a>.</p><p>Digital image capture was provided by <a href="http://www.micrographics.co.nz">New Zealand Micrographic Services Ltd.</a></p><p>Commentaries on titles provided by Gail Dallimore.</p><p><gsf:link type="page" page="abexpl">English abstracts</gsf:link> are provided by a team working through the Department of Māori Studies at the University of Auckland.</p>
 
Index: /main/trunk/model-cols/niupepa/resources/niupepa_mi.properties
===================================================================
--- /main/trunk/model-cols/niupepa/resources/niupepa_mi.properties	(revision 26480)
+++ /main/trunk/model-cols/niupepa/resources/niupepa_mi.properties	(revision 26481)
@@ -17,14 +17,14 @@
 simple.query=Tirohia ki {0-subcolllist} mÅ {1-some/all} o ngÄ kupu {2-query box}
 about.changelangtofrommaori=View the collection in English
-about.textxwelcome=<h2>Nau mai ki te Kohikohinga Niupepa MÄori</h2>
-about.textxwelcome2=<p>Kua whakaemitia mai ki konei he kohikohinga niupepa i tÄngia mÅ ngÄ kaipÄnui MÄori o ngÄ tau 1842-1932. E taea te pÄnui niupepa mÄ te <gsf:link type="query">rapu kupu</gsf:link>, i te <gsf:link type="classifier" nodeID="CL1">rÄrangi taitara</gsf:link>, me te rÄrangi <gsf:link type="classifier" nodeID="CL2">wÄtaka</gsf:link> hoki. He mea i whakatÅ«ria e te kaupapa <a href="http://www.nzdl.org">New Zealand Digital Library</a>, i te <a href="http://www.cs.waikato.ac.nz/cs/">Tari Rorohiko</a>, o te <a href="http://www.waikato.ac.nz">Whare WÄnanga o Waikato</a>.</p>
-about.textxbackground=<p>Kei raro nei he kupu whakamÄrama e pÄ ana ki te kohikohinga nei.</p>
-about.textxgrateful=<p>Ka nui te mihi ki ngÄ rÅpÅ« tautoko i te kaupapa nei. NÄ tÄ rÄtou tautoko kua kore he utu, mÄ koutou, mÅ te titiro ki ngÄ niupepa nei. Ko te <a href="http://www.minedu.govt.nz">TÄhuhu o te MÄtauranga</a> tÄrÄ, me Ätehi whare pukapuka e noho mai nei ki ngÄ whare wÄnanga o te motu. Tirohia ngÄ rÅpÅ« tautoko.</p>
+about.textxwelcome=Nau mai ki te Kohikohinga Niupepa MÄori
+about.textxwelcome2=Kua whakaemitia mai ki konei he kohikohinga niupepa i tÄngia mÅ ngÄ kaipÄnui MÄori o ngÄ tau 1842-1932. E taea te pÄnui niupepa mÄ te <gsf:link type="query">rapu kupu</gsf:link>, i te <gsf:link type="classifier" nodeID="CL1">rÄrangi taitara</gsf:link>, me te rÄrangi <gsf:link type="classifier" nodeID="CL2">wÄtaka</gsf:link> hoki. He mea i whakatÅ«ria e te kaupapa <a href="http:/www.nzdl.org">New Zealand Digital Library</a>, i te <a href="http://www.cs.waikato.ac.nz/cs/">Tari Rorohiko</a>, o te <a href="http://www.waikato.ac.nz">Whare WÄnanga o Waikato</a>.
+about.textxbackground=Kei raro nei he <a href="#background">kupu whakamÄrama</a> e pÄ ana ki te kohikohinga nei.
+about.textxgrateful=Ka nui te mihi ki ngÄ rÅpÅ« tautoko i te kaupapa nei. NÄ tÄ rÄtou tautoko kua kore he utu, mÄ koutou, mÅ te titiro ki ngÄ niupepa nei. Ko te <a href="http://www.minedu.govt.nz">TÄhuhu o te MÄtauranga</a> tÄrÄ, me Ätehi whare pukapuka e noho mai nei ki ngÄ whare wÄnanga o te motu. Tirohia ngÄ <a href="#support">rÅpÅ« tautoko</a>.
 
-about.textxbackground2=<h2>He Kupu WhakamÄrama</h2>
+about.textxbackground2=He Kupu WhakamÄrama
 about.textxbackground3=<p>He nui ake i te 17,700 whÄrangi, mai i te 34 niupepa kei te kohikohinga nei. He mea hanga i te &quot;Niupepa 1842-1933&quot;, te kohinga kua whakaemihia e te <a href="http://www.natlib.govt.nz/en/using/8atl.html">Alexander Turnbull Library</a> ki runga i te kiriata mororiki. E 70% kei te reo MÄori, 27% kei ngÄ reo e rua, Ä, kua Ähua 3% kei te reo PÄkehÄ. E toru ngÄ kaupapa matua o ngÄ niupepa nei: he hÄpainga kÄwanatanga; he pÄnui rÄnei nÅ ngÄ iwi MÄori; he kupu whakapono rÄnei nÅ ngÄ hÄhi. </p><p>E whÄ ngÄ wÄhanga nui o te kohikohinga niupepa MÄori:</p><ul><li>ngÄ whakaahua o te whÄrangi niupepa</li><li>ngÄ kupu kua tangohia (mÅ te rapu) i aua whÄrangi</li><li>he kupu whakataki mÅ ia niupepa</li><li>he <gsf:link type="page" page="abexpl">rÄpopototanga reo PÄkehÄ</gsf:link></li></ul><p>MÅ Ätehi atu kÅrero pÄnuitia te pukapuka Rere Atu Taku Manu! Discovering History, Language &amp; Politics in the MÄori Language Newspapers. NÄ Jennifer Curnow, rÄtou ko Ngapare Hopa, ko Jane McRae. Auckland University Press (2002).</p>
 
-about.textxsupporgs=<h2>RÅpÅ« Tautoko</h2>
-about.textyaymined=<p>Ko te tino tautoko o te kaupapa nei, i puta i te <a href="http://www.minedu.govt.nz">TÄhuhu o te MÄtauranga</a>.</p>
+about.textxsupporgs=RÅpÅ« Tautoko
+about.textyaymined=Ko te tino tautoko o te kaupapa nei, i puta i te <a href="http://www.minedu.govt.nz">TÄhuhu o te MÄtauranga</a>.
 about.textxsupporgs2=<p>ArÄ anÅ hoki ngÄ tautoko i tukua mai e ngÄ whare pukapuka o ngÄ whare wÄnanga:</p><ul><li><a href="http://www.waikato.ac.nz/library/">Te Whare Pukapuka o te Whare WÄnanga o Waikato</a></li><li><a href="http://www.library.otago.ac.nz">Te Whare Pukapuka o te Whare WÄnanga o Otago</a></li><li><a href="http://www.massey.ac.nz/~wwwlib/">Te Whare Pukapuka o te Whare WÄnanga o Massey</a></li><li><a href="http://www.victoria.ac.nz/library/">Te Whare Pukapuka o te Whare WÄnanga o Victoria</a></li><li><a href="http://www2.auckland.ac.nz/lbr/">Te Whare Pukapuka o te Whare WÄnanga o Auckland</a></li><li><a href="http://library.canterbury.ac.nz">Te Whare Pukapuka o te Whare WÄnanga o Canterbury</a></li><li><a href="http://prod.lincoln.ac.nz/libr/default.htm">Te Whare Pukapuka o te Whare WÄnanga o Lincoln</a></li></ul><p>Kei runga te kohinga &quot;Niupepa 1842-1933&quot; i te kiriata mÅkito 35mm me te kiriata mororiki. Ka taea te tono atu ki te whare pukapuka o tÅ rohe, ka taea rÄnei te hoko, mai i te <a href="http://www.natlib.govt.nz/en/using/8atl.html">Alexander Turnbull Library</a>. </p><p>NÄ te <a href="http://www.micrographics.co.nz">New Zealand Micrographic Services Ltd.</a> i whakawhiti ngÄ whakaahua, mai i te kiriata mÅkito ki te whakatakotoranga TIFF. </p><p>NÄ Gail Dallimore ngÄ kupu whakataki. </p><p>NÄ tÄtehi rÅpu rangahau i te Tari MÄori o te Whare WÄnanga o TÄmaki i whakarite ngÄ <gsf:link type="page" page="abexpl">rÄpopototanga reo PÄkehÄ</gsf:link>.</p>
 