Index: /main/trunk/greenstone3/web/interfaces/default/transform/pages/debuginfo.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/pages/debuginfo.xsl	(revision 26483)
+++ /main/trunk/greenstone3/web/interfaces/default/transform/pages/debuginfo.xsl	(revision 26484)
@@ -10,5 +10,5 @@
 	<!-- use the 'main' layout -->
 	<xsl:include href="layouts/main.xsl"/>
-
+  <xsl:variable name="debug_property_file" select="concat($interface_name, '2')"/>
 	<!-- set page title -->
 	<xsl:template name="pageTitle"><gslib:collectionName/></xsl:template>
@@ -19,19 +19,19 @@
 	<!-- the page content -->
 	<xsl:template match="/page">
-	  <p><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.usage')"/></p>
+	  <p><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.usage')"/></p>
 
 	  <dl>
 	    <dt>o=xml</dt>
-	    <dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.xml')"/></dd>
+	    <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.xml')"/></dd>
 	    <dt>o=xmlfinal</dt>
-	    <dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.xmlfinal')"/></dd>
+	    <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.xmlfinal')"/></dd>
 	    <dt>o=skindoc</dt>
-	    <dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.skindoc')"/></dd>
+	    <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.skindoc')"/></dd>
 	    <dt>o=skinandlib</dt>
-	    <dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.skinandlib')"/></dd>
+	    <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.skinandlib')"/></dd>
 	    <dt>o=skinandlibdoc</dt>
-	    <dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.skinandlibdoc')"/></dd>
+	    <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.skinandlibdoc')"/></dd>
 	    <dt>formatedit=on</dt>
-	    <dd><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'debuginfo.formatedit')"/></dd>
+	    <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.formatedit')"/></dd>
 	  </dl>	  
 
@@ -39,5 +39,5 @@
 
 
-	  <!-- better to do the following with a util:getInterfaceText()
+	  <!-- better to do the following with a util:getInterfaceText
 	       so language independent -->
 	  <p>Refresh all the collection configuration files:</p>
Index: /main/trunk/greenstone3/web/interfaces/default/transform/pages/help.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/pages/help.xsl	(revision 26483)
+++ /main/trunk/greenstone3/web/interfaces/default/transform/pages/help.xsl	(revision 26484)
@@ -10,7 +10,7 @@
 	<!-- use the 'main' layout -->
 	<xsl:include href="layouts/main.xsl"/>
-
+  <xsl:variable name="help_interface_name" select="concat($interface_name, '2')"/>
 	<!-- set page title -->
-	<xsl:template name="pageTitle"><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'help_b')"/></xsl:template>
+	<xsl:template name="pageTitle"><xsl:value-of select="util:getInterfaceText($help_interface_name, /page/@lang, 'help_b')"/></xsl:template>
 
 	<!-- set page breadcrumbs -->
@@ -25,7 +25,12 @@
 	<xsl:template match="page">
 		<xsl:call-template name="helpTopics"/>
-		<xsl:if test="/page/pageResponse/collection">
+		<xsl:choose>
+      <xsl:when test="/page/pageResponse/collection">
 			<xsl:call-template name="findingInformationHelp"/>
-		</xsl:if>
+	</xsl:when>
+      <xsl:otherwise>
+	<xsl:call-template name="homePageHelp"/>
+	</xsl:otherwise>
+		</xsl:choose>
 		<xsl:call-template name="readingDocsHelp"/>
 		<xsl:call-template name="searchingHelp"/>
@@ -37,4 +42,7 @@
 	</xsl:template>
 
+  <xsl:template name="homePageHelp">
+    home page help
+  </xsl:template>
 	<xsl:template name="findingInformationHelp">
 		<xsl:variable name="searchEnabled">
@@ -49,6 +57,6 @@
 		</xsl:variable>
 
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.findinginformationtitle')"/>
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.findinginformation', $searchEnabled + $numClassifiers)"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.findinginformationtitle')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.findinginformation', $searchEnabled + $numClassifiers)"/>
 		
 		<!-- using actual <ul> and <li> tags here would cause the XML parser to break -->
@@ -56,5 +64,5 @@
 		<xsl:if test="$searchEnabled = 1">
 			<xsl:text disable-output-escaping="yes">&lt;li&gt;</xsl:text>
-			<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.searchdesc')"/>
+			<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.searchdesc')"/>
 			<xsl:text disable-output-escaping="yes">&lt;/li&gt;</xsl:text>
 		</xsl:if>
@@ -62,5 +70,5 @@
 		<xsl:for-each select="/page/pageResponse/collection[@name=$collName]/serviceList/service[@name = 'ClassifierBrowse']/classifierList/classifier">
 			<xsl:text disable-output-escaping="yes">&lt;li&gt;</xsl:text>
-			<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.browsedesc', ./displayItem[@name = 'name'])"/>
+			<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.browsedesc', ./displayItem[@name = 'name'])"/>
 			<xsl:text disable-output-escaping="yes">&lt;/li&gt;</xsl:text>
 		</xsl:for-each>
@@ -69,16 +77,16 @@
 	
 	<xsl:template name="readingDocsHelp">
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.readingdocstitle')"/>
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.readingdocs')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.readingdocstitle')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.readingdocs')"/>
 		
 		<table>
 			<tr>
 				<td colspan="2"><img src="interfaces/default/images/bookshelf.png"/></td>
-				<td><xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.openbookshelf')"/></td>
+				<td><xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.openbookshelf')"/></td>
 			</tr>
 			<tr>
 				<td><img src="interfaces/default/images/previous.png"/></td>
 				<td><img src="interfaces/default/images/next.png"/></td>
-				<td><xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.sectionarrows')"/></td>
+				<td><xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.sectionarrows')"/></td>
 			</tr>
 		</table>
@@ -86,36 +94,36 @@
 	
 	<xsl:template name="searchingHelp">
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.searchingtitle')"/>
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.searching')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.searchingtitle')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.searching')"/>
 		
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.querytermstitle')"/>
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.queryterms')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.querytermstitle')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.queryterms')"/>
 		
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.querytypetitle')"/>
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.querytype')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.querytypetitle')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.querytype')"/>
 		
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.queryscopetitle')"/>
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.queryscope')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.queryscopetitle')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.queryscope')"/>
 	</xsl:template>
 	
 	<xsl:template name="preferencesHelp">
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.changingpreferencestitle')"/>
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.changingpreferences')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.changingpreferencestitle')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.changingpreferences')"/>
 		
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.collectionpreferencestitle')"/>
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.collectionpreferences')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.collectionpreferencestitle')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.collectionpreferences')"/>
 		
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.languagepreferencestitle')"/>
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.languagepreferences')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.languagepreferencestitle')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.languagepreferences')"/>
 		
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.presentationpreferencestitle')"/>
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.presentationpreferences')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.presentationpreferencestitle')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.presentationpreferences')"/>
 		
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.searchpreferencestitle')"/>
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.searchpreferences1')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.searchpreferencestitle')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.searchpreferences1')"/>
 		<xsl:if test="/page/pageResponse/collection[@name=$collName and (@type='mgpp' or @type='mg')]">
-			<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.mgsearchpreferences')"/>
+			<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.mgsearchpreferences')"/>
 		</xsl:if>
-		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($interface_name, /page/@lang, 'help.searchpreferences2')"/>
+		<xsl:value-of disable-output-escaping="yes" select="util:getInterfaceText($help_interface_name, /page/@lang, 'help.searchpreferences2')"/>
 	</xsl:template>
 </xsl:stylesheet>