Index: /gs3-extensions/i-jetty/trunk/src/README.txt
===================================================================
--- /gs3-extensions/i-jetty/trunk/src/README.txt	(revision 26520)
+++ /gs3-extensions/i-jetty/trunk/src/README.txt	(revision 26521)
@@ -26,12 +26,26 @@
 Having sourced the setup file the two main steps are:
 
-  1) Install i-jetty
+  1) Install i-jetty on the Android device
 
-  2) Install Greenstone3 as a web-app 
-     (converting any jar and class files to DEX format)
+  2) Install Greenstone3 as a web-app application on Andoird device
 
-The first step typically only needs to be done once. The second step is
-composed of three sub-steps, and may require the last two sub-steps to
-be repeated if the Java code has been modified.
+The first step typically only needs to be done once. 
+
+
+The key task for the second step is to transfer greenstone3's "web"
+directory to /sdcard/jetty/webapps/ on the Android device.  In
+principle that would be:
+
+  <GSDL3SRCHOME>/web -> <ANDROID-DEVICE>:/sdcard/jetty/webapps/greenstone3
+
+However we need to convert all the Java code (which lurks in Jar
+files) in the "web" folder into DEX-byte-code equivalents first.  We
+therefore break this step of the installation down into sub-steps (see
+below).  In overview, we create a "webapps" folder in the *extension*
+folder, where we copy the static file content of "web" to (i.e., the
+non-Java stuff).  We then top that up with Dexified versions of the
+Java code.  Finally the whole "webapps/greenstone3" folder in the
+extensions area is copied over to the Android device.
+
 
 Step 1
@@ -70,15 +84,17 @@
 --------
 
-Transfer the bulk of the <GSDL3SRCHOME>/web structure to the 
-<SDCARD>/ijetty/webapps/greenstone3 with:
+Transfer the bulk of the <GSDL3SRCHOME>/web structure to the preparation
+area "webapps" with the extension foler (i.e., where you are running these
+scripts from) with:
 
-
-  WEBAPP-ROOT-TO-SDCARD.sh
+  ./PREPARE-WEBAPPS-GREENSTONE-ROOT-FOR-IJETTY.sh
 
 This script skips any .svn files if present.  It also skips installing
-'localsite' as this is rather large -- both in size and in terms of
-the number of files invovled -- so copying is rather slow, and it is
-probably not what you want anyway.
-
+the majority of 'localsite' as this can be rather large -- both in
+size and in terms of the number of files invovled -- so copying is
+rather slow, and it is probably not what you want anyway.  Only the
+'lucene-jdbm-demo' collection is copied to the preparation area.
+Any other collections you wish to add should be manually added to
+the "webapps/greenstone3/sites/localsite/collect/" area.
 
 Step 2.2
@@ -88,8 +104,10 @@
 classs.dex with:
 
-  JAVA-TO-DEX.sh  
+  ./JAVA-TO-DEX.sh  
 
-The finished file, which is also by this point zipped up, is left in
-the 'lib' folder.
+The finished file, which is also by this point zipped up, is stored in
+the 'lib' folder (should you wish to inspect it).  It is also
+automatically copied to "webapps/greenstone3/WEB-INF/lib" which is
+where it needs to be to work when installed on the Android device.
 
 
@@ -97,12 +115,12 @@
 --------
 
-Copy classes.zip onto the Android's sd-card
+Copy Greenstone3's webapps folder onto the Android device's sd-card:
 
-  DEX-TO-SDCARD.sh  
+  ./IJETTY-PUSH.sh webapps/greenstone3
 
 This is the final step in getting Greenstone3 setup on an Andoird.
 Switch off the USB disk mode on the Android device.  Note: it can take
-a device minute or two "preparing" the sd-card.  This can be seen
-on the notification view.  Alternativey, if you try to start i-jetty
+a device minute or two "preparing" the sd-card.  This can be seen on
+the notification view.  Alternativey, if you try to start i-jetty
 before the card is ready, then i-jetty points this out, and offers you
 a 'retry' button.
@@ -116,9 +134,11 @@
 web-browser application.  We've tested the built-in web browser, and
 Mobile Firefox 4.
+====
 
-
-If the Java code to Greenstone3 is changed, then you need to repeat sub-steps
-2.2 and 2.3
-
+If the compiled Java code to Greenstone3 has changed, then you need to
+repeat sub-steps 2.2 and 2.3.  Transfering just the newly
+dexified code can be achieved more quickly by entering:
+  
+ ./IJETTY-PUSH.sh webapps/greenstone3/WEB-INF/lib
 
 
@@ -131,8 +151,7 @@
    support.
 
-
 2. Due to a runtime (reflection) error, we had to modify xalan.jar.
-   The modified version of this file is also in the 'jars' folder
-   used in this extension.
+   The modified version of this file is also in the 'modified-jars'
+   folder used in this extension.
 
 