Index: gs3-extensions/i-jetty/trunk/src/setup.bash
===================================================================
--- gs3-extensions/i-jetty/trunk/src/setup.bash	(revision 26521)
+++ gs3-extensions/i-jetty/trunk/src/setup.bash	(revision 26522)
@@ -1,7 +1,6 @@
-
-
 
 if [ "x$ANDROID_SDK_HOME" = "x" ] ; then
   if [ ! -e setup-android.bash ] ; then
+    echo ""
     echo "Unable to find 'setup-android.bash'.  You either need to:" 1>&2
     echo "  1) copy setup-android.bash.in to setup-android.bash and" 1>&2
@@ -10,80 +9,80 @@
     echo "  2) Explicitly set the environment variable ANDROID_SDK_HOME" 1>&2
     echo "     and make sure 'dx' is on your PATH" 1>&2
-    exit
   else 
     source setup-android.bash
+
+    export IJETTY_HOME=`pwd`
+    export IJOS=`uname | sed 's/^cygwin.*$/cygwin/i' | sed 's/^mingw.*$/mingw/i'`
+    
+    if [ "x$GSDL3HOME" = "x" ] ; then
+	echo "  Setting GSDL3HOME to '../../web'"
+	export GSDL3HOME=../../web
+    else 
+	echo "Using existing value of GSDL3HOME: '$GSDL3HOME'"
+    fi
+    
+    export PREPARE_SDCARD_GSDL3HOME=$IJETTY_HOME/webapps/greenstone3/
+    
+    export WITHIN_SDCARD_WEBAPPS=/sdcard/jetty/webapps
+    export WITHIN_SDCARD_GSDL3HOME=$WITHIN_SDCARD_WEBAPPS/greenstone3
+    
+    echo ""
+    echo "  Using:"
+    echo ""
+    echo "     $PREPARE_SDCARD_GSDL3HOME"
+    echo ""
+    echo "  as the webapps *preparation* area for the Greenstone servlet"
+    echo ""
+    echo "  Using:"
+    echo ""
+    echo "     $WITHIN_SDCARD_GSDL3HOME"
+    echo ""
+    echo "  as the *installation* point for the Greenstone servlet on the sd-card"
+    echo ""
+
+
+    if [ "x$IJETTY_PORT" = "x" ] ; then
+	export IJETTY_PORT=8080
+	echo ""
+	echo "  Setting IJETTY_PORT to 8080"
+	echo "  Explicityly set this environment variable to override this default"
+	echo ""
+    else
+	echo ""
+	echo "  Using IJETTY PORT = $IJETTY_PORT"
+	echo ""
+    fi
+
+    echo "+ Your environment has now been set up with iJetty extension for Greenstone"
+
+    echo ""
+    echo "======"
+    echo "If this is the first time you have installed Greenstone on the Android device, "
+    echo " run:"
+    echo ""
+    echo "   adb install i-jetty-3.1-signed-aligned.apk"
+    echo ""
+    echo "to install jetty on your device, followed by"
+    echo ""
+    echo "  ./PREPARE-WEBAPPS-GREENSTONE-ROOT-FOR-IJETTY.sh"
+    echo ""
+    echo "to set up Greenstone3's 'web' directory for the i-jetty webapps area."
+    echo ""
+    echo "Then:"
+    echo ""
+    echo "  ./JAVA-TO-DEX.sh"
+    echo ""
+    echo "to cross-compile Greenstone java code to the Android DEX format and add it to the webapps area."
+    echo ""
+    echo "Finally run:"
+    echo ""
+    echo "  ./IJETTY-PUSH.sh webapps/greenstone3"
+    echo ""
+    echo "to install the Greenstone3's webapps folder (including cross-compiled DEX files) on the Android device"
+    echo "======"
+    echo ""
+
   fi
 fi
-
-export IJETTY_HOME=`pwd`
-export IJOS=`uname | sed 's/^cygwin.*$/cygwin/i' | sed 's/^mingw.*$/mingw/i'`
-
-if [ "x$GSDL3HOME" = "x" ] ; then
-  echo "  Setting GSDL3HOME to '../../web'"
-  export GSDL3HOME=../../web
-else 
-  echo "Using existing value of GSDL3HOME: '$GSDL3HOME'"
-fi
-
-export PREPARE_SDCARD_GSDL3HOME=$IJETTY_HOME/webapps/greenstone3/
-
-export WITHIN_SDCARD_WEBAPPS=/sdcard/jetty/webapps
-export WITHIN_SDCARD_GSDL3HOME=$WITHIN_SDCARD_WEBAPPS/greenstone3
-
-echo ""
-echo "  Using:"
-echo ""
-echo "     $PREPARE_SDCARD_GSDL3HOME"
-echo ""
-echo "  as the webapps *preparation* area for the Greenstone servlet"
-echo ""
-echo "  Using:"
-echo ""
-echo "     $WITHIN_SDCARD_GSDL3HOME"
-echo ""
-echo "  as the *installation* point for the Greenstone servlet on the sd-card"
-echo ""
-
-
-if [ "x$IJETTY_PORT" = "x" ] ; then
-  export IJETTY_PORT=8080
-  echo ""
-  echo "  Setting IJETTY_PORT to 8080"
-  echo "  Explicityly set this environment variable to override this default"
-  echo ""
-else
-  echo ""
-  echo "  Using IJETTY PORT = $IJETTY_PORT"
-  echo ""
-fi
-
-echo "+ Your environment has now been set up with iJetty extension for Greenstone"
-
-echo ""
-echo "======"
-echo "If this is the first time you have installed Greenstone on the Android device, "
-echo " run:"
-echo ""
-echo "   adb install i-jetty-2.2-signed.apk"
-echo ""
-echo "to install jetty on your device, followed by"
-echo ""
-echo "  ./PREPARE-WEBAPPS-GREENSTONE-ROOT-FOR-IJETTY.sh"
-echo ""
-echo "to set up Greenstone3's 'web' directory for the i-jetty webapps area."
-echo ""
-echo "Then:"
-echo ""
-echo "  ./JAVA-TO-DEX.sh"
-echo ""
-echo "to cross-compile Greenstone java code to the Android DEX format and add it to the webapps area."
-echo ""
-echo "Finally run:"
-echo ""
-echo "  ./IJETTY-PUSH.sh webapps/greenstone3"
-echo ""
-echo "to install the Greenstone3's webapps folder (including cross-compiled DEX files) on the Android device"
-echo "======"
-echo ""
 
 
@@ -91,3 +90,2 @@
 
 
-